﻿/*
Copyright(c) 2017 株式会社トラスト・ソフトウェア・システム
無断転載を禁止します。
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using PDFTools.PdfImagerLP;

namespace ImagerApp
{
	public partial class LayerDlg : Form
	{
		public OcgUsage[] ocgUsage;

		public LayerDlg(OcgUsage[] ou)
		{
			InitializeComponent();
			ocgUsage = ou;
		}

		private void LayerDlg_Shown(object sender, EventArgs e)
		{
			string[] item = new string[4];
			for (int i = 0; i < ocgUsage.Length; i++)
			{
				item[0] = ocgUsage[i].id.ToString();
				item[1] = ocgUsage[i].level.ToString();
				item[2] = ocgUsage[i].visible == 1 ? "表示" : "非表示";
				item[3] = ocgUsage[i].name;
				layerLv.Items.Add(new ListViewItem(item));
			}
		}
	}
}
